=== debian/changelog ===
libzip (1.7.3-1) unstable; urgency=medium

  * New upstream version 1.7.3
  * Fix the SOVERSION revert patch
  * Add new cmake helper files to libzip-dev
  * Update d/libzip4.symbols

 -- Ondřej Surý <ondrej@debian.org>  Sat, 10 Oct 2020 21:01:16 +0200

libzip (1.6.1-3) unstable; urgency=medium

  * It's never a good time to do unnecessary SONAME bump, it's a burden
    on an archive just for a single removed symbol.  Revert the SONAME
    bump again.
  * Repair the damaged d/changelog
  * Upload to unstable.

 -- Ondřej Surý <ondrej@debian.org>  Tue, 28 Apr 2020 14:44:21 +0200

libzip (1.6.1-2) experimental; urgency=medium

  [ Stefan Schoerghofer ]
  * Fixed changelog and control file

 -- Stefan Schörghofer <amd1212@4md.gr>  Wed, 8 Apr 2020 10:29:05 +0200

libzip (1.6.1-1) experimental; urgency=medium

  [ Stefan Schoerghofer ]
  * New upstream version 1.6.1
  * Removed SONAME lowering-patch. zip PROPERTIES VERSION
    updated to 5.1 so it appears to be a good time to do the SONAME
    bump.

 -- Stefan Schörghofer <amd1212@4md.gr>  Fri, 21 Feb 2020 12:58:37 +0100
