=== debian/watch ===
version=3
https://libzip.org/download/libzip-(.*)\.tar\.xz
