## libzip 1.11.1

=== debian/changelog ===
libzip (1.11.1-1~exp1) experimental; urgency=medium

  * New upstream version 1.11.1 (Closes: #984512, #1004588)
  * Transition the package from libzip4t64 to libzip5
  * Update the libzip5 symbols
  * libzip-dev: Add dependency on zipcmp (Closes: #973280)
  * Remove Stephan as Maintainer, add Florian to Uploaders

 -- Ondřej Surý <ondrej@debian.org>  Wed, 09 Oct 2024 17:16:11 +0200

libzip (1.7.3-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Rename libraries for 64-bit time_t transition.  Closes: #1062743

 -- Steve Langasek <vorlon@debian.org>  Fri, 01 Mar 2024 07:27:55 +0000
