=== debian/control ===
--- 
+++ 
@@ -1,9 +1,11 @@
 Source: libzip
 Priority: optional
-Maintainer: Stefan Schörghofer <amd1212@4md.gr>
-Uploaders: Ondřej Surý <ondrej@debian.org>
+Maintainer: Debian Libzip Maintainers <libzip@tracker.debian.org>
+Uploaders: Ondřej Surý <ondrej@debian.org>,
+	   Florian Ernst <florian@debian.org>
 Build-Depends: cmake,
                debhelper-compat (= 12),
+               dpkg-dev (>= 1.22.5),
                libbz2-dev,
                libssl-dev,
                mandoc,
@@ -20,7 +22,8 @@
 Section: libdevel
 Architecture: any
 Multi-Arch: same
-Depends: libzip4 (= ${binary:Version}),
+Depends: libzip5 (= ${binary:Version}),
+         zipcmp (= ${binary:Version}),
          zlib1g-dev,
          ${misc:Depends}
 Description: library for reading, creating, and modifying zip archives (development)
@@ -31,7 +34,8 @@
  This package contains the static libraries and headers for developing
  applications that use the libzip library API.
 
-Package: libzip4
+Package: libzip5
+Provides: ${t64:Provides}
 Architecture: any
 Multi-Arch: same
 Pre-Depends: ${misc:Pre-Depends}
