## libzip 1.11.2

=== debian/changelog ===
libzip (1.11.2-1) unstable; urgency=medium

  * New upstream version 1.11.2

 -- Florian Ernst <florian@debian.org>  Mon, 04 Nov 2024 15:23:54 +0100

libzip (1.11.1-1) unstable; urgency=medium

  * Uploading to unstable to start the transition (cf. #1085204)
  * d/copyright: redo for DEP-5
  * d/README.source: now obsolete and thus dropped
  * d/watch: use version=4
  * d/control: drop obsolete t64:Provides
  * d/control: switch to debhelper-compat (= 13) as already present in stable.
    Thus obsoleting the dh_missing override in d/rules.
  * d/*.lintian-overrides: drop obsolete possible-gpl-code-linked-with-openssl
  * d/libzip5.symbols: add Build-Depends-Package field
  * d/rules: use DEB_BUILD_MAINT_OPTIONS = hardening=+all
  * d/rules: drop dh_link override creating a now-unnecessary dir
  * d/control: mark zip* utils as Multi-Arch: foreign
  * d/tests/: add autopkgtest based on upstream examples
  * d/control: Standards-Version: 4.7.0 (no further changes required)
  * d/.gitlab-ci.yml: reprotest now works reliably

 -- Florian Ernst <florian@debian.org>  Wed, 23 Oct 2024 14:58:40 +0200
