=== debian/control ===
--- 
+++ 
@@ -4,14 +4,14 @@
 Uploaders: Ondřej Surý <ondrej@debian.org>,
 	   Florian Ernst <florian@debian.org>
 Build-Depends: cmake,
-               debhelper-compat (= 12),
+               debhelper-compat (= 13),
                dpkg-dev (>= 1.22.5),
                libbz2-dev,
                libssl-dev,
                mandoc,
                unzip,
                zlib1g-dev
-Standards-Version: 4.3.0.1
+Standards-Version: 4.7.0
 Section: libs
 Rules-Requires-Root: no
 Homepage: https://libzip.org
@@ -35,7 +35,6 @@
  applications that use the libzip library API.
 
 Package: libzip5
-Provides: ${t64:Provides}
 Architecture: any
 Multi-Arch: same
 Pre-Depends: ${misc:Pre-Depends}
@@ -52,6 +51,7 @@
 Package: zipcmp
 Section: utils
 Architecture: any
+Multi-Arch: foreign
 Depends: ${misc:Depends},
          ${shlibs:Depends}
 Description: compare contents of zip archives
@@ -62,6 +62,7 @@
 Package: zipmerge
 Section: utils
 Architecture: any
+Multi-Arch: foreign
 Depends: ${misc:Depends},
          ${shlibs:Depends}
 Description: merge zip archives
@@ -72,6 +73,7 @@
 Package: ziptool
 Section: utils
 Architecture: any
+Multi-Arch: foreign
 Depends: ${misc:Depends},
          ${shlibs:Depends}
 Description: modify zip archives
