=== debian/changelog ===
libzip (1.11.3-2) unstable; urgency=medium

  * [e0e170d] d/control: let libzip-dev also Depend on zipmerge and ziptool.
    They are required when using cmake. (Closes: #1094641, #973280)
  * [644407f] d/control: add B-D on liblzma-dev and libzstd-dev
    (Closes: #1095482)
  * [8fa04a6] d/copyright: update years for debian packaging
  * [963f7e9] d/gbp.conf: set "debian-branch = main"

 -- Florian Ernst <florian@debian.org>  Wed, 12 Feb 2025 15:03:17 +0100

libzip (1.11.3-1) unstable; urgency=medium

  * New upstream version 1.11.3

 -- Florian Ernst <florian@debian.org>  Thu, 23 Jan 2025 18:11:57 +0100
