=== debian/control ===
--- 
+++ 
@@ -7,7 +7,9 @@
                debhelper-compat (= 13),
                dpkg-dev (>= 1.22.5),
                libbz2-dev,
+               liblzma-dev,
                libssl-dev,
+               libzstd-dev,
                mandoc,
                unzip,
                zlib1g-dev
@@ -24,6 +26,8 @@
 Multi-Arch: same
 Depends: libzip5 (= ${binary:Version}),
          zipcmp (= ${binary:Version}),
+         zipmerge (= ${binary:Version}),
+         ziptool (= ${binary:Version}),
          zlib1g-dev,
          ${misc:Depends}
 Description: library for reading, creating, and modifying zip archives (development)
